<?php

  require_once "include/function/signer.php";
  require_once "include/class/config.php";
	
	//retrieve params
	if(isset($_GET['user']) ){ $user = strip_tags(trim($_GET['user']) ); }else{ $user = '';};
	if(isset($_GET['from']) ) $from = strip_tags(trim($_GET['from']) );
	if(isset($_GET['to'])  ) $to 	= strip_tags(trim($_GET['to']) );
	if(isset($_GET['a'])   ) $action	= strip_tags(trim($_GET['a']) );
	if (isset($_GET['period']) ){
		$period = set_range(strip_tags(trim($_GET['period']) ) );
		$from = $period[0];
		$to = $period[1];
	}
	
	//setup vars
	$path 	= 'reports/';
	$fh		= '';
	$file	= $path . 'report_' . $action . '_' . $user . '_' . rand() . '.csv';
	$header	= "Vendor Name; Verdict; Timestamp\r\n";
	
	$dsn  = 'host='.HOST;
	$dsn .= ' port='.PORT;
	$dsn .= ' user='.USER;
	$dsn .= ' password='.PASSWORD;
	$dsn .= ' dbname='.DB_NAME;
    $db_conn=pg_connect($dsn);

	foreach(glob($path.'*.*') as $v){
    	unlink($v);
	}
	
	$sql = "SELECT csh.\"Ts\", csh.\"UserId\", csh.\"VerdictId\", csh.\"SubjectId\", csh.\"IsReviewed\", cs.\"Name\" as \"VendorName\", us.\"UserName\", csv.\"Name\" as \"VerdictName\"
	FROM cert_subjects_history as csh, cert_subjects as cs, users as us, cert_subject_verdicts as csv
	WHERE csh.\"UserId\"=us.\"UserId\" AND csh.\"VerdictId\"= csv.\"Id\" AND csh.\"SubjectId\" = cs.\"SubjectId\" AND csh.\"Ts\" BETWEEN '". $from ."' AND '". $to ."'";
	if($action == 'user') $sql .=" AND us.\"UserName\"='". $user . "'";
	switch($action){
		case 'rogue':
			$sql .= " AND csh.\"VerdictId\"='1'";
			break;
		case 'trusted-rev':
			$sql .= " AND csh.\"VerdictId\"='2' AND csh.\"IsReviewed\"='t'";
			break;
		case 'trusted-nrev':
			$sql .= " AND csh.\"VerdictId\"='2' AND csh.\"IsReviewed\"='f'";
			break;
		case 'grey':
			$sql .= " AND csh.\"VerdictId\"='3'";
			break;
		case 'undet':
			$sql .= " AND csh.\"VerdictId\"='4'";
			break;
		case 'unknown':
			$sql .= " AND csh.\"VerdictId\"='0'";
			break;
		default:
			$sql .= " ORDER BY csh.\"VerdictId\" ";
	}
	if($action != 'user') $sql .= " ORDER BY us.\"UserName\" ";
	//echo $sql; exit();
	
	$res = pg_query($db_conn, $sql);
	$result = pg_fetch_all($res);

	
	if($result){
		//open tmp file for writting
		$fh = fopen($file, "w");
		fwrite($fh, "\xEF\xBB\xBF", 3);
		fwrite($fh, $header);
		$oldUsr = '';
		if($action == 'user'){
			fwrite($fh," ===========================================; ==========; =========\r\n" );				
			foreach($result as $k)
				fwrite($fh,$k['VendorName'] .'; '. $k['VerdictName'] .'; '. date('d-m-Y', strtotime($k['Ts'])) . "\r\n" );				
		}else{
			foreach($result as $k){
				if($oldUsr === $k['UserName']){
					fwrite($fh,$k['VendorName'] .'; '. $k['VerdictName'] .'; '. date('d-m-Y', strtotime($k['Ts'])) . "\r\n" );				
				}else{
					fwrite($fh,"\r\n\r\n[ ". $k['UserName'] ." ]===================================; ======; =========\r\n" );				
					fwrite($fh,$k['VendorName'] .'; '. $k['VerdictName'] .'; '. date('d-m-Y', strtotime($k['Ts'])) . "\r\n" );
					$oldUsr = $k['UserName'];
				}
			}

		}	
				
		header('Content-Description: File Transfer');
		header('Content-Type: application/octet-stream');
		header('Content-Disposition: attachment; filename='.$file);
		header('Content-Transfer-Encoding: binary');
		header("Content-length: ". filesize($file));
		header('Expires: 0');
		header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
		header('Pragma: public');
		
		ob_clean();
		flush();
		readfile($file);
		
	}else{echo 'There is no data to report!'; }

?>